#!/bin/sh NeXtMidas shell finalization script must be sourced
#
# @author  J. Czechowski IV
# @version $Id: nmend.sh,v 1.1 2015/06/05 18:14:19 jxc Exp $
#
unalias nm         2>> /dev/null
unalias nmprofile  2>> /dev/null
unalias nmd        2>> /dev/null
unalias nmend      2>> /dev/null
unalias nmedit     2>> /dev/null

if [ -n "$NM_SF" ]; then
  \rm -f $NM_SF.msf $NM_SF.bat
fi


# Remove ONLY the NM_* variables that we set.
#   JC4: Since some users have various NM_USER_* variables we can't just.
#        remove all NM_* variables.

unset NM_JB
unset NM_OS
unset NM_OPT
unset NM_DIR
unset NM_PID
unset NM_SF
unset NM_XP
unset NM_CP
unset NM_JAVA
unset NM_JAVAC

unset NM_JVM_FLAGS
unset NM_PROFILER_FLAGS
unset NM_SAVE_FLAGS
unset JAVA2D_USEPLATFORMFONT
