package nxm.sys.intr;

/** Handle a block <code>LOOP</code> control statement. This implements the <code>LOOP</code> loop
    in NeXtMidas Macros. <br>
    <br>
    The <code>LOOP</code> command is just a simplified version of the <code>DO</code> command, but
    has been added cor compatibility with X-Midas.
    
    @author  J. Czechowski IV
    @version $Id: Loop.java,v 1.1 2007/07/24 15:35:30 jxc Exp $
    @since   NeXtMidas 2.5.0
    
    @see Do
    @see Endloop
 */
public class Loop extends Do {
  /** Creates a new instance of a LOOP loop. */
  public Loop () { super(LOOP); }
}