c************
c  Description: Include file for XRTPLOT Datastream & Host Primitives
c
c  $Revision: 1.1 $
c  $Modtime:   03/19/96 13:23:08  $
c
c************

	implicit none
	include 'types.inc'
	include 'xdsprim.inc'
	include 'msgmask.inc'
	include 'xfacilities.inc'
	include 'parameters.inc'

	logical*4 XRTPLOT_PAN_HANDLE
	integer*4 XRTPLOT_RUN

	structure /GX/
	  record /M_PTR/ lpix, lbuf, fbuf, rbuf
	  record /XFACILITIES/ xf
	  real*8	retx,rety,xmrk,ymrk,aretx,arety,dretx,drety
	  real*8	xstart,xdelta,xmin,xmax
	  character*16	mouse
	  integer*4	mframe,iautom,iautol,nxf
	  integer*4	iabsc,type,lps,ncolors
	  integer*4	xlab,ylab,xdiv,ydiv
	  integer*4	ixlab,iylab,markm,marks
	  character*20	xfmt,yfmt
	  integer*4	class,cntrls,cmode,imouse
	  integer*4	nelem,melem,loff,status
	  integer*4	mimic,ldo,e1,events
	  integer*4	pass,hold,j1,j2
	  integer*4	trace,thick,symbol,radius
	  logical*1	autoexit,clear,cx,edge,fast,nowrap,specs,yinv
	  real*4	rmin,rmax,rmin0,rmax0
	  real*4	ymin,ymax,dbmin,dbrange
	  record /PIXSTRUCT/ markp, click
	  logical*4	grid
	  real*4	tclick
	  integer*2	pan,panbutton
	  integer*4	FILL
	endstructure

	record /GX/ Gx
	integer*4 L_Gx
	parameter (L_Gx = 4*L_M_Ptr+L_XFacilities+2*L_PixStruct+44*8)

	integer*4 t_auto, t_autol, t_clear, t_cntrls, t_edge, t_events
	integer*4 t_fast, t_grid, t_markm, t_marks, t_mimic, t_msgid
	integer*4 t_specs, t_wrap, t_xdivisions, t_xlabel, t_ydivisions
	integer*4 t_yinv, t_ylabel

	parameter (t_auto	= 1)
	parameter (t_autol	= t_auto+1)
	parameter (t_clear	= t_autol+1)
	parameter (t_cntrls	= t_clear+1)
	parameter (t_edge	= t_cntrls+1)
	parameter (t_events	= t_edge+1)
	parameter (t_fast	= t_events+1)
	parameter (t_grid	= t_fast+1)
	parameter (t_markm	= t_grid+1)
	parameter (t_marks	= t_markm+1)
	parameter (t_mimic	= t_marks+1)
	parameter (t_msgid	= t_mimic+1)
	parameter (t_specs	= t_msgid+1)
	parameter (t_wrap	= t_specs+1)
	parameter (t_xdivisions	= t_wrap+1)
	parameter (t_xlabel	= t_xdivisions+1)
	parameter (t_ydivisions	= t_xlabel+1)
	parameter (t_yinv	= t_ydivisions+1)
	parameter (t_ylabel	= t_yinv+1)

