package optiontrees;

import nxm.sys.inc.OptionTreeAutoLoaderInterface;

/**
 * Defines the provider class implementation for OptionTreeAutoLoaderInterface
 * for DSP. There may be other implementations for the other NeXtMidas option
 * trees.
 *
 * NOTE: This is just the beginning for Service Provider Interface
 * Please be aware that this is still under development and it made
 * change in the future.
 *
 * @author jjv
 * @since 3.7.1
 */

public class OptionTreeDSP implements OptionTreeAutoLoaderInterface {

  /**
   * @return the option tree where this service is used
   */
  @Override
  public String getOptionTreeName () {
    return "DSP";
  }
}
